# Welcome to Laravel Docker Config

This is a simple Docker Compose workflow that sets up a LEMP network of containers for local Laravel development

## Configuration requirements

To use the fpm image, you need an additional web server, such as nginx, that can proxy http-request to the fpm-port of the container. For fpm connection this container exposes port 9000.

 - Web-server: Nginx
 - DBMS (database management system): mariadb
 - PHP Framework: Laravel
 - In-memory database: Redis
 - SSL Certificate (using mkcert)
 
## Steps

### 1. Install ssl certificate
Using mkcert to create ssl certificate

#### For Ubuntu

```shell
sudo apt install libnss3-tools

sudo wget https://github.com/FiloSottile/mkcert/releases/download/v1.4.3/mkcert-v1.4.3-linux-amd64 && \
sudo mv mkcert-v1.4.3-linux-amd64 mkcert && \
sudo chmod +x mkcert && \
sudo cp mkcert /usr/local/bin/
```

Now that the mkcert utility is installed, run the command below to generate and install your local CA:

```shell
mkcert -install
```

### 2. Create ssl certificate for this project

Run:

```shell
cd docker/server/certs
mkcert local.laravel.nginx.com
```

### 3. Run to setup: 

```shell
docker-compose up -d
docker-compose run server composer install
docker-compose run server npm install
docker-compose run server cp .env.example .env
docker-compose run server php artisan key:generate
```

### 4. Modify **.env** on laravel source

## Check the network ID of DB

- Run `docker ps` to check the Container ID of **APP_NAME-db**
- Run the command `docker inspect -f '{{range.NetworkSettings.Networks}}{{.IPAddress}}{{end}}' <container ID>`

## This is the demo of the result:
![image](https://user-images.githubusercontent.com/35853002/162612441-0084d99f-bd24-4c4c-8f50-350f642bab50.png)
